Index: /trunk/expressoAdmin1_2/setup/tables_update.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/setup/tables_update.inc.php	(revision 46)
+++ /trunk/expressoAdmin1_2/setup/tables_update.inc.php	(revision 47)
@@ -9,5 +9,5 @@
 	* option) any later version.                                               *
 	\**************************************************************************/	
-	$test[] = '1.24';
+	$test[] = '1.240';
 	function expressoAdmin1_2_upgrade1_221()
 	{
@@ -31,5 +31,5 @@
 	}
 	
-	function expressoAdmin1_2_upgrade1_24() 
+	function expressoAdmin1_2_upgrade1_240() 
 	{
 		
Index: /trunk/expressoAdmin1_2/setup/setup.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/setup/setup.inc.php	(revision 46)
+++ /trunk/expressoAdmin1_2/setup/setup.inc.php	(revision 47)
@@ -13,5 +13,5 @@
 	$setup_info['expressoAdmin1_2']['title']     	= 'ExpressoAdmin 1.2';
 	/* Ao incrementar versão, não esquecer de declarar função do tables_update.inc.php*/
-	$setup_info['expressoAdmin1_2']['version']   	= '1.24';
+	$setup_info['expressoAdmin1_2']['version']   	= '1.240';
 	$setup_info['expressoAdmin1_2']['app_order']	= 1;
 	$setup_info['expressoAdmin1_2']['tables'][]		= 'phpgw_expressoadmin';
Index: /trunk/expressoAdmin1_2/docs/change_log.txt
===================================================================
--- /trunk/expressoAdmin1_2/docs/change_log.txt	(revision 41)
+++ /trunk/expressoAdmin1_2/docs/change_log.txt	(revision 47)
@@ -80,2 +80,9 @@
 	- deixa a opção desmarcado caso não existe nenhum sambaDomain na OU.
 	- Seleciona automaticamente o sambaDomain da OU.
+
+03/07/2007 - [1.240]
+- Corrigido problema na atualização do módulo usando o SETUP.
+
+09/08/2007
+- Corrigido bug ao adicionar email em grupos
+- Corrigido bug ao adicionar atributos samba a um usuários já existente.
Index: /trunk/expressoAdmin1_2/inc/class.user.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/inc/class.user.inc.php	(revision 46)
+++ /trunk/expressoAdmin1_2/inc/class.user.inc.php	(revision 47)
@@ -548,6 +548,6 @@
 						$ldap_add['objectClass'][] 			= 'sambaSamAccount';
 						$ldap_mod_replace['loginShell']		= '/bin/bash';
-						$ldap_add['sambaSID']				= $this->current_config['expressoAdmin_sambaSID'] . '-' . ((2 * $new_values['uidnumber'])+1000);
-						$ldap_add['sambaPrimaryGroupSID']	= $this->current_config['expressoAdmin_sambaSID'] . '-' . ((2 * $new_values['gidnumber'])+1001);
+						$ldap_add['sambaSID']				= $new_values['sambadomain'] . '-' . ((2 * $new_values['uidnumber'])+1000);
+						$ldap_add['sambaPrimaryGroupSID']	= $new_values['sambadomain'] . '-' . ((2 * $new_values['gidnumber'])+1001);
 						$ldap_add['sambaAcctFlags']			= $new_values['sambaacctflags'];
 						$ldap_add['sambaLogonScript']		= $new_values['sambalogonscript'];
Index: /trunk/expressoAdmin1_2/inc/class.imap_functions.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/inc/class.imap_functions.inc.php	(revision 46)
+++ /trunk/expressoAdmin1_2/inc/class.imap_functions.inc.php	(revision 47)
@@ -28,5 +28,5 @@
 			return $result;
 		}
-		if (!imap_createmailbox($this->imap, '{'.$this->imap_server.'}' . "user" . $this->imapDelimiter . $uid . $this->imapDelimiter . "Sent"))
+		if (!imap_createmailbox($this->imap, '{'.$this->imap_server.'}' . "user" . $this->imapDelimiter . $uid . $this->imapDelimiter . "Enviados"))
 		{
 			$error = imap_errors();
@@ -35,5 +35,5 @@
 			return $result;
 		}
-		if (!imap_createmailbox($this->imap, '{'.$this->imap_server.'}' . "user" . $this->imapDelimiter . $uid . $this->imapDelimiter . "Drafts"))
+		if (!imap_createmailbox($this->imap, '{'.$this->imap_server.'}' . "user" . $this->imapDelimiter . $uid . $this->imapDelimiter . "Rascunhos"))
 		{
 			$error = imap_errors();
@@ -42,5 +42,5 @@
 			return $result;
 		}
-		if (!imap_createmailbox($this->imap, '{'.$this->imap_server.'}' . "user" . $this->imapDelimiter . $uid . $this->imapDelimiter . "Trash"))
+		if (!imap_createmailbox($this->imap, '{'.$this->imap_server.'}' . "user" . $this->imapDelimiter . $uid . $this->imapDelimiter . "Lixeira"))
 		{
 			$error = imap_errors();
Index: /trunk/expressoAdmin1_2/inc/class.functions.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/inc/class.functions.inc.php	(revision 46)
+++ /trunk/expressoAdmin1_2/inc/class.functions.inc.php	(revision 47)
@@ -230,5 +230,5 @@
 				
 				$justthese = array("uidnumber", "uid", "cn", "mail");
-				$filter="(&(phpgwAccountType=u)(|(uid~=".$query.")(sn~=".$query.")(cn~=".$query.")(givenName~=".$query.")(mail~=$query)(mailAlternateAddress~=$query)))";
+				$filter="(&(phpgwAccountType=u)(|(uid=*".$query."*)(sn=*".$query."*)(cn=*".$query."*)(givenName=*".$query."*)(mail=$query*)(mailAlternateAddress=$query*)))";
 				$search=ldap_search($ldap_conn, $context, $filter, $justthese);
 				ldap_sort($ldap_conn, $search, "uid");
Index: /trunk/expressoAdmin1_2/js/jscode/groups.js
===================================================================
--- /trunk/expressoAdmin1_2/js/jscode/groups.js	(revision 46)
+++ /trunk/expressoAdmin1_2/js/jscode/groups.js	(revision 47)
@@ -322,4 +322,7 @@
 function groupEmailSuggestion(concatenateDomain, type)
 {
+	if (document.forms[0].email.disabled)
+		return;
+	
 	if (type != 'create_group')
 		return;
@@ -353,7 +356,7 @@
 		org_name = org_name_par.split('.');
 		org_name = org_name[org_name.length-1];
-	
+		
 		if (org_name != '')
-			document.forms[0].email.value = document.forms[0].cn.value + '@' + org_name + '.' + domain_name;
+			document.forms[0].email.value = document.forms[0].cn.value + '@' + org_name + '.aaa' + domain_name;
 		else
 			document.forms[0].email.value = document.forms[0].cn.value;
Index: /trunk/expressoAdmin1_2/js/jscode/users.js
===================================================================
--- /trunk/expressoAdmin1_2/js/jscode/users.js	(revision 33)
+++ /trunk/expressoAdmin1_2/js/jscode/users.js	(revision 47)
@@ -108,5 +108,5 @@
 
 	// Uid & Mail exist?
-	attrs_array = new Array();
+	var attrs_array = new Array();
 	attrs_array['type'] = type;
 	attrs_array['uid'] = document.forms[0].uid.value;
@@ -114,5 +114,5 @@
 	if (document.forms[0].mailalternateaddress.value != '')
 		attrs_array['mailalternateaddress'] = document.forms[0].mailalternateaddress.value;
-	attributes = connector.serialize(attrs_array);
+	var attributes = connector.serialize(attrs_array);
 
 	var handler_validate_fields = function(data)
@@ -190,10 +190,9 @@
 	if (!data.status){
 		alert(data.msg);
-		location.href="./index.php?menuaction=expressoAdmin1_2.uiaccounts.list_users";
 	}
 	else{
 		alert('Usuário salvo com êxito!!');
-		location.href="./index.php?menuaction=expressoAdmin1_2.uiaccounts.list_users";
-	}
+	}
+	location.href="./index.php?menuaction=expressoAdmin1_2.uiaccounts.list_users";
 	return;
 }
Index: /trunk/expressoAdmin1_2/templates/default/groups_form.tpl
===================================================================
--- /trunk/expressoAdmin1_2/templates/default/groups_form.tpl	(revision 46)
+++ /trunk/expressoAdmin1_2/templates/default/groups_form.tpl	(revision 47)
@@ -26,5 +26,6 @@
 							<select id="ea_combo_org_info" name="context" onchange="javascript:sinc_combos_org(this.value, ea_check_allUsers.checked); get_available_sambadomains(this.value, '{type}')">{combo_manager_org}</select><br>
 							{lang_group_name}: <font color="blue">Ex: grupo-celepar-rh</font>
-							<input name="cn" size="35" value="{cn}" autocomplete="off" onKeyUp="javascript:groupEmailSuggestion('{concatenateDomain}','{type}')"><br>
+							<!--<input name="cn" size="35" value="{cn}" autocomplete="off" onKeyUp="javascript:groupEmailSuggestion('{concatenateDomain}','{type}')"><br>-->
+							<input name="cn" size="35" value="{cn}" autocomplete="off"><br>
 							{lang_email}:<br>
 							<input name="email" size="60" value="{email}" {disable_email_groups} autocomplete="off"><br>
Index: /trunk/doc-expressolivre/arqs-conf-suse/header.inc.php
===================================================================
--- /trunk/doc-expressolivre/arqs-conf-suse/header.inc.php	(revision 2)
+++ /trunk/doc-expressolivre/arqs-conf-suse/header.inc.php	(revision 47)
@@ -10,4 +10,5 @@
 	*  option) any later version.                                              *
 	\**************************************************************************/
+	/* $Id$ */
 
 	/**************************************************************************\
Index: /trunk/doc-expressolivre/arqs-conf/header.inc.php
===================================================================
--- /trunk/doc-expressolivre/arqs-conf/header.inc.php	(revision 2)
+++ /trunk/doc-expressolivre/arqs-conf/header.inc.php	(revision 47)
@@ -10,4 +10,5 @@
 	*  option) any later version.                                              *
 	\**************************************************************************/
+	/* $Id$ */
 
 	/**************************************************************************\