Index: trunk/news_admin/setup/setup.inc.php
===================================================================
--- trunk/news_admin/setup/setup.inc.php	(revision 45)
+++ trunk/news_admin/setup/setup.inc.php	(revision 49)
@@ -10,5 +10,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	/* Basic information about this app */
Index: trunk/news_admin/setup/default_records.inc.php
===================================================================
--- trunk/news_admin/setup/default_records.inc.php	(revision 45)
+++ trunk/news_admin/setup/default_records.inc.php	(revision 49)
@@ -10,5 +10,4 @@
   \**************************************************************************/
 
-  /* $Id$ */
 
 //	$oProc->query("DELETE FROM phpgw_news");
Index: trunk/news_admin/setup/tables_baseline.inc.php
===================================================================
--- trunk/news_admin/setup/tables_baseline.inc.php	(revision 45)
+++ trunk/news_admin/setup/tables_baseline.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
    // table array for news_admin
Index: trunk/news_admin/setup/tables_current.inc.php
===================================================================
--- trunk/news_admin/setup/tables_current.inc.php	(revision 45)
+++ trunk/news_admin/setup/tables_current.inc.php	(revision 49)
@@ -14,5 +14,4 @@
   \**************************************************************************/
 
-  /* $Id$ */
 
   // table array for news_admin
Index: trunk/news_admin/setup/tables_update.inc.php
===================================================================
--- trunk/news_admin/setup/tables_update.inc.php	(revision 45)
+++ trunk/news_admin/setup/tables_update.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	$test[] = '0.0.1';
Index: trunk/news_admin/website/export.php
===================================================================
--- trunk/news_admin/website/export.php	(revision 45)
+++ trunk/news_admin/website/export.php	(revision 49)
@@ -13,5 +13,4 @@
   \**************************************************************************/
 
-  /* $Id$ */
 
 	include('setup.inc.php');
Index: trunk/news_admin/website/news.inc.php
===================================================================
--- trunk/news_admin/website/news.inc.php	(revision 45)
+++ trunk/news_admin/website/news.inc.php	(revision 49)
@@ -12,5 +12,4 @@
 	* http://www.goldenglair.com                                               *
 	\**************************************************************************/
-	/* $Id$ */
 
 	include('setup.inc.php');
Index: trunk/news_admin/website/index.php
===================================================================
--- trunk/news_admin/website/index.php	(revision 45)
+++ trunk/news_admin/website/index.php	(revision 49)
@@ -14,5 +14,4 @@
   \**************************************************************************/
 
-  /* $Id$ */
   
   include("news.inc.php");
Index: trunk/news_admin/website/setup.inc.php
===================================================================
--- trunk/news_admin/website/setup.inc.php	(revision 45)
+++ trunk/news_admin/website/setup.inc.php	(revision 49)
@@ -13,5 +13,4 @@
   \**************************************************************************/
 
-  /* $Id$ */
 
 	$path_to_header = '../../';
Index: trunk/news_admin/admin_edit.php
===================================================================
--- trunk/news_admin/admin_edit.php	(revision 45)
+++ trunk/news_admin/admin_edit.php	(revision 49)
@@ -13,5 +13,4 @@
   \**************************************************************************/
 
-  /* $Id$ */
 
 	$phpgw_info = array();
Index: trunk/news_admin/inc/class.bonews.inc.php
===================================================================
--- trunk/news_admin/inc/class.bonews.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.bonews.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class bonews
Index: trunk/news_admin/inc/class.uiacl.inc.php
===================================================================
--- trunk/news_admin/inc/class.uiacl.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.uiacl.inc.php	(revision 49)
@@ -11,5 +11,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class uiacl
Index: trunk/news_admin/inc/hook_preferences.inc.php
===================================================================
--- trunk/news_admin/inc/hook_preferences.inc.php	(revision 45)
+++ trunk/news_admin/inc/hook_preferences.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-  /* $Id$ */
 {
 // Only Modify the $file and $title variables.....
Index: trunk/news_admin/inc/hook_sidebox_menu.inc.php
===================================================================
--- trunk/news_admin/inc/hook_sidebox_menu.inc.php	(revision 45)
+++ trunk/news_admin/inc/hook_sidebox_menu.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-  /* $Id$ */
 {
 
Index: trunk/news_admin/inc/class.sonews.inc.php
===================================================================
--- trunk/news_admin/inc/class.sonews.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.sonews.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class sonews
Index: trunk/news_admin/inc/class.uiexport.inc.php
===================================================================
--- trunk/news_admin/inc/class.uiexport.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.uiexport.inc.php	(revision 49)
@@ -11,5 +11,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class uiexport
Index: trunk/news_admin/inc/class.boacl.inc.php
===================================================================
--- trunk/news_admin/inc/class.boacl.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.boacl.inc.php	(revision 49)
@@ -11,5 +11,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class boacl
Index: trunk/news_admin/inc/class.soacl.inc.php
===================================================================
--- trunk/news_admin/inc/class.soacl.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.soacl.inc.php	(revision 49)
@@ -11,5 +11,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class soacl
Index: trunk/news_admin/inc/class.boexport.inc.php
===================================================================
--- trunk/news_admin/inc/class.boexport.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.boexport.inc.php	(revision 49)
@@ -11,5 +11,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class boexport
Index: trunk/news_admin/inc/class.soexport.inc.php
===================================================================
--- trunk/news_admin/inc/class.soexport.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.soexport.inc.php	(revision 49)
@@ -11,5 +11,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class soexport
Index: trunk/news_admin/inc/hook_admin.inc.php
===================================================================
--- trunk/news_admin/inc/hook_admin.inc.php	(revision 45)
+++ trunk/news_admin/inc/hook_admin.inc.php	(revision 49)
@@ -10,5 +10,4 @@
   *  option) any later version.                                              *
   \**************************************************************************/
-  /* $Id$ */
 	{
 		$file = Array
Index: trunk/news_admin/inc/hook_home.inc.php
===================================================================
--- trunk/news_admin/inc/hook_home.inc.php	(revision 45)
+++ trunk/news_admin/inc/hook_home.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	$showevents = (int)$GLOBALS['phpgw_info']['user']['preferences']['news_admin']['homeShowLatest'];
Index: trunk/news_admin/inc/class.uinews.inc.php
===================================================================
--- trunk/news_admin/inc/class.uinews.inc.php	(revision 45)
+++ trunk/news_admin/inc/class.uinews.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	class uinews
Index: trunk/news_admin/inc/hook_settings.inc.php
===================================================================
--- trunk/news_admin/inc/hook_settings.inc.php	(revision 45)
+++ trunk/news_admin/inc/hook_settings.inc.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	$show_entries = array(
Index: trunk/news_admin/index.php
===================================================================
--- trunk/news_admin/index.php	(revision 45)
+++ trunk/news_admin/index.php	(revision 49)
@@ -13,5 +13,4 @@
 	\**************************************************************************/
 
-	/* $Id$ */
 
 	$phpgw_info = array();