Index: trunk/expressoMail1_2/js/draw_api.js
===================================================================
--- trunk/expressoMail1_2/js/draw_api.js	(revision 51)
+++ trunk/expressoMail1_2/js/draw_api.js	(revision 53)
@@ -38,5 +38,5 @@
 		tree_folders = new dFTree({name: 'tree_folders'});
 
-		var n_root = new dNode({id:'root', caption:'Minhas Pastas'});
+		var n_root = new dNode({id:'root', caption: get_lang("My Folders")});
 		tree_folders.add(n_root,'anything'); //Places the root; second argument can be anything.
 	
@@ -51,5 +51,5 @@
 			else if (folders[i].folder_parent == 'user'){
 				if (!tree_folders.getNodeById('user')){
-					var n_root_shared_folders = new dNode({id:'user', caption:'Pastas compartilhadas', plusSign:true}); 
+					var n_root_shared_folders = new dNode({id:'user', caption:get_lang("Shared folders"), plusSign:true}); 
 					tree_folders.add(n_root_shared_folders,'root');
 				}
@@ -83,5 +83,5 @@
 	}
 	if(folder_create != ""){
-		if(confirm("Existem pastas com formato inválido.Deseja corrigi-las?")){
+		if(confirm(get_lang("There are folders with invalid format. Do you want to fix them?"))){
 			var handler_correct_folders = function(data){
 				//Timeout to release HTTPRequest , loadScript and update tree folders.
@@ -815,5 +815,5 @@
 	var option_reply_without_history		= '<span class="message_options" onclick=new_message("reply_without_history","'+ID+'");>'+get_lang("Reply without history")+'</span> | ';
 	var option_reply_to_all_without_history	= '<span class="message_options" onclick=new_message("reply_to_all_without_history","'+ID+'");>'+get_lang("Reply to all without history")+'</span> | ';
-	var option_source_msg					= '<span class="message_options" onclick=source_msg("'+ID+'","'+url_encode(info_msg.msg_folder)+'");>'+get_lang("Font Message")+'</span>';	
+	var option_source_msg					= '<span class="message_options" onclick=source_msg("'+ID+'","'+url_encode(info_msg.msg_folder)+'");>'+get_lang("Message Font")+'</span>';	
 
 	div_other_options.innerHTML = option_mark_as + option_mark_as_unseen + option_mark_as_important + option_mark_as_normal + option_move + option_reply_to_all + option_reply_without_history + option_reply_to_all_without_history + option_source_msg;
@@ -1189,5 +1189,5 @@
 	if ((preferences.save_in_folder == '-1') || (preferences.save_in_folder == '')){
 		var option_send			= '<span class="message_options" onclick=send_message("'+ID+'","null","null");>'+get_lang("Send")+'</span> | ';
-		var option_send_and_file= '<span class="message_options" onclick=wfolders.makeWindow("'+ID+'","send_and_file");>'+get_lang("Send and File")+'</span> | ';
+		var option_send_and_file= '<span class="message_options" onclick=wfolders.makeWindow("'+ID+'","send_and_file");>'+get_lang("Send and Store")+'</span> | ';
 	}
 	else{
@@ -1292,5 +1292,5 @@
 	var img_search = document.createElement("IMG");
 	img_search.src = "./templates/default/images/search.gif";
-	img_search.title = get_lang('Search') + " | " + get_lang('Use F9 Key for shortcut.');
+	img_search.title = get_lang('Search') + " | " + get_lang('Use F9 Key as shortcut.');
 	img_search.onclick = function () {emQuickSearch(document.getElementById('to_'+ID).value, 'to', ID);};
 	var span_search = document.createElement("SPAN");
@@ -1375,5 +1375,5 @@
 	img_search.src = "./templates/default/images/search.gif";
 	img_search.onclick = function () {emQuickSearch(document.getElementById('cc_'+ID).value, 'cc', ID)}
-	img_search.title = get_lang('Search') + " | " + get_lang('Use F9 Key for shortcut.');
+	img_search.title = get_lang('Search') + " | " + get_lang('Use F9 Key as shortcut.');
 	var span_search = document.createElement("SPAN");
 	span_search.innerHTML = get_lang('Search');
@@ -1455,5 +1455,5 @@
 	var img_search = document.createElement("IMG");
 	img_search.src = "./templates/default/images/search.gif";
-	img_search.title = get_lang('Search') + " | " + get_lang('Use F9 Key for shortcut.');	
+	img_search.title = get_lang('Search') + " | " + get_lang('Use F9 Key as shortcut.');	
 	img_search.onclick = function () {emQuickSearch(document.getElementById('cco_'+ID).value, 'cco', ID);};
 	var span_search = document.createElement("SPAN");
@@ -1835,5 +1835,5 @@
 	if(value > 90) {
 		if(value >= 100)
-			write_msg(get_lang("Your Mailbox is 100% full! You must to free more space or will not receive messages."));
+			write_msg(get_lang("Your Mailbox is 100% full! You must free more space or will not receive messages."));
 		else
 			write_msg(get_lang("Warning: Your Mailbox is almost full!"));