Index: /trunk/expressoMail1_2/js/abas.js
===================================================================
--- /trunk/expressoMail1_2/js/abas.js	(revision 2)
+++ /trunk/expressoMail1_2/js/abas.js	(revision 58)
@@ -67,5 +67,5 @@
 		window_DropDownContacts.style.visibility = 'hidden';
 	}
-		
+	Element("footer_menu").style.display = ID ? 'none' : '';
 	return ID;
 }
@@ -82,5 +82,5 @@
 		}
 	}
-
+	Element("footer_menu").style.display = 'none';
 	var ID = id_value ? id_value : parseInt(BordersArray[(BordersArray.length-1)].sequence) + 1;
 	
@@ -229,4 +229,6 @@
 		}
 	}
+	if(j == 1)
+		Element("footer_menu").style.display = '';
 	BordersArray = new_BordersArray;
 }
Index: /trunk/expressoMail1_2/js/main.js
===================================================================
--- /trunk/expressoMail1_2/js/main.js	(revision 53)
+++ /trunk/expressoMail1_2/js/main.js	(revision 58)
@@ -17,4 +17,5 @@
 
 		ConstructMenuTools();
+		resizeWindow();
 		cExecute ("$this.imap_functions.get_folders_list", update_menu);
 	}
Index: /trunk/expressoMail1_2/js/draw_api.js
===================================================================
--- /trunk/expressoMail1_2/js/draw_api.js	(revision 53)
+++ /trunk/expressoMail1_2/js/draw_api.js	(revision 58)
@@ -99,5 +99,5 @@
 		draw_tree_folders(data);
 		if(data) {
-			build_quota(data);
+			build_quota(data);			
 			var f_unseen = Element('dftree_'+get_current_folder()+'_unseen');
 			if(f_unseen && f_unseen.innerHTML)
@@ -379,14 +379,14 @@
 		_divScroll.style.overflow = "-moz-scrollbars-vertical";
 		_divScroll.style.width	="99.3%";
-		// Inicio: Redimensiona DIV SCROLL
-		var bar = Element("toolbar");
-		var offset = 0;
-		if(bar.style.visibility != 'hidden') 
-			offset = (bar.offsetHeight ? bar.offsetHeight :  bar.clientHeight);		
-		var screenHeight = document.body.clientHeight ? document.body.clientHeight : document.body.offsetHeight;
-		var defaultHeight = screenHeight - offset;		
-		_divScroll.style.height 	= defaultHeight - 118;
-		// Fim: Redimensiona DIV SCROLL
-	}
+	}
+	// Inicio: Redimensiona DIV SCROLL
+	var bar = Element("toolbar");
+	var offset = 0;
+	if(bar.style.visibility != 'hidden') 
+		offset = (bar.offsetHeight ? bar.offsetHeight :  bar.clientHeight);		
+	var screenHeight = document.body.clientHeight ? document.body.clientHeight : document.body.offsetHeight;
+	var defaultHeight = screenHeight - offset;		
+	_divScroll.style.height 	= defaultHeight - 110;
+	// Fim: Redimensiona DIV SCROLL
 	_divScroll.appendChild(table_element);
 	content_id_0.appendChild(_divScroll);
@@ -404,5 +404,5 @@
 	tdFolders.style.display = preferences.hide_folders == '1'  ? "none" : "";
 	alternate_border(0);
-	resizeWindow();	
+	//resizeWindow();	
 	draw_footer_box(headers_msgs.num_msgs);	
 	Element('main_table').style.display = '';
@@ -2101,31 +2101,27 @@
 }
 function draw_footer_box(num_msgs){
-	var span_T = document.createElement("TABLE");
-	span_T.style.visibility = 'hidden';	
-	span_T.id = "footer_box";
-	span_T.border = "0px";
-	span_T.cellPadding = "0px";
-	span_T.cellSpacing = "0px";
-	span_T.width = "100%";
-	span_T.style.height = "10";
-	span_T.style.borderTop = "1px solid black";		
-	var span_B = document.createElement("TBODY");
-	var span_R = document.createElement("TR");
-	span_R.className = "table_message";
-	span_B.appendChild(span_R);
-	span_T.appendChild(span_B);
-	var span_options = document.createElement("TD");	
-	span_options.style.fontSize = "12";
-	span_options.innerHTML = 
-	'<span title="'+get_lang("Delete")+'" style="margin-left:8px" class="message_options" onclick=delete_msgs(\'null\',\'selected\',\'null\')>'+get_lang("Delete")+'</span> | '+
-	'<span title="'+get_lang("Move")+'" class="message_options" onclick=wfolders.makeWindow(\"\",\"move_to\")>'+get_lang("Move")+'</span> | '+
-   	'<span title="'+get_lang("Print")+'" class="message_options" onclick=print_all()>'+get_lang("Print")+'</span> | '+
-   	'<span title="'+get_lang("Export")+'" class="message_options" onclick="export_all_selected_msgs()">'+get_lang("Export")+'</span>';
-   	
-	var span_D = document.createElement("TD");	
-	span_D.align = "right";
-	span_D.style.fontSize = "12";
+	var span_R = Element("table_message");	
+	var span_options = Element("span_options");	
+	if(!span_options) {
+		span_options = document.createElement("TD");	
+		span_options.style.fontSize = "12";
+		span_options.id = "span_options";
+		span_options.innerHTML = 
+		'<span title="'+get_lang("Delete")+'" style="margin-left:8px" class="message_options" onclick=delete_msgs(\'null\',\'selected\',\'null\')>'+get_lang("Delete")+'</span> | '+
+		'<span title="'+get_lang("Move")+'" class="message_options" onclick=wfolders.makeWindow(\"\",\"move_to\")>'+get_lang("Move")+'</span> | '+
+	   	'<span title="'+get_lang("Print")+'" class="message_options" onclick=print_all()>'+get_lang("Print")+'</span> | '+
+	   	'<span title="'+get_lang("Export")+'" class="message_options" onclick="export_all_selected_msgs()">'+get_lang("Export")+'</span>';
+		span_R.appendChild(span_options);
+	}   	
+	var span_D = Element("span_D");	
+	if(!span_D){
+		span_D = document.createElement("TD");	
+		span_D.align = "right";
+		span_D.style.fontSize = "12";
+		span_D.id = "span_D";
+		span_R.appendChild(span_D);
+	}
 	span_D.innerHTML = 
-   	 get_lang("List")+': '+
+   		 get_lang("List")+': '+
    	'<span id="span_flag_SORTARRIVAL" style="'+(search_box_type == 'ALL' ? 'font-weight:bold;text-decoration:underline' : '')+'" title="'+get_lang("All")+'" class="message_options" onclick="if(\'ALL\' == \''+search_box_type+'\') return false;sort_box(\'ALL\',\''+sort_box_type+'\')">'+get_lang("all")+'</span>, '+
    	'<span id="span_flag_UNSEEN" style="'+(search_box_type == 'UNSEEN' ? 'font-weight:bold;text-decoration:underline' : '')+'" title="'+get_lang("Unseen")+'" class="message_options" onclick="if(\'UNSEEN\' == \''+search_box_type+'\') return false;sort_box(\'UNSEEN\',\''+sort_box_type+'\')">'+get_lang("Unseen")+'s</span>, '+
@@ -2133,10 +2129,4 @@
    	'<span id="span_flag_ANSWERED" style="'+(search_box_type == 'ANSWERED' ? 'font-weight:bold;text-decoration:underline' : '')+'" title="'+get_lang("Answered")+'" class="message_options" onclick="if(\'ANSWERED\' == \''+search_box_type+'\') return false;sort_box(\'ANSWERED\',\''+sort_box_type+'\')">'+get_lang("answered").toLowerCase()+'s</span>, '+
    	'<span id="span_flag_FLAGGED" style="'+(search_box_type == 'FLAGGED' ? 'font-weight:bold;text-decoration:underline' : '')+'" title="'+get_lang("important")+'" class="message_options" onclick="if(\'FLAGGED\' == \''+search_box_type+'\') return false;sort_box(\'FLAGGED\',\''+sort_box_type+'\')">'+get_lang("important")+'s</span>&nbsp;&nbsp;';
-
-	span_R.appendChild(span_options);
-	span_R.appendChild(span_D);		
-	var content_id_0 = document.getElementById("content_id_0");
-	content_id_0.appendChild(span_T);
-	span_T.style.visibility = 'visible';
 	draw_paging(num_msgs);
 	Element("tot_m").innerHTML = num_msgs;	
Index: /trunk/expressoMail1_2/templates/default/index.tpl
===================================================================
--- /trunk/expressoMail1_2/templates/default/index.tpl	(revision 37)
+++ /trunk/expressoMail1_2/templates/default/index.tpl	(revision 58)
@@ -38,8 +38,6 @@
 				</div>
 				
-			</td>
-			
-			<td width="2px">&nbsp;</td>
-			
+			</td>			
+			<td width="2px">&nbsp;</td>			
 			<td width="*" valign="top" align="left">
 				<div id="main_body" class="messagescol">
@@ -54,4 +52,11 @@
 					</table>
 					<div id="content_id_0" class="conteudo"></div>
+					<div id="footer_menu">
+						<table style="border-top:0px solid black" id="footer_box" cellpadding=0 cellspacing=0 border=0 width="100%" height="10px">
+							<tbody>
+								<tr id="table_message"></tr>
+							</tbody>					
+						</table>					
+					</div>
 				</div>
 			</td>